Subject: Re: riscv defconfig CONFIG_PM/macb/generic PHY regression in v5.18-rc1

From: Andrew Lunn <[email-masked]>
Date: Tue, 5 Apr 2022 20:06:50 +0200

> I tried using the one for the VSC8662 (0007.0660) since that's whats on,
> the board but that didn't help.
> Without the revert:
> 
> [    1.521768] macb 20112000.ethernet eth0: Cadence GEM rev 0x0107010c at
> 0x20112000 irq 17 (00:04:a3:4d:4c:dc)
> [    3.206274] macb 20112000.ethernet eth0: PHY
> [20112000.ethernet-ffffffff:09] driver [Vitesse VSC8662] (irq=POLL)
> [    3.216641] macb 20112000.ethernet eth0: configuring for phy/sgmii link
> mode
> (and then nothing)
> 
> If I revert the CONFIG_PM addition:
> 
> [    1.508882] macb 20112000.ethernet eth0: Cadence GEM rev 0x0107010c at
> 0x20112000 irq 17 (00:04:a3:4d:4c:dc)
> [    2.879617] macb 20112000.ethernet eth0: PHY
> [20112000.ethernet-ffffffff:09] driver [Vitesse VSC8662] (irq=POLL)
> [    2.890010] macb 20112000.ethernet eth0: configuring for phy/sgmii link
> mode
> [    6.981823] macb 20112000.ethernet eth0: Link is Up - 1Gbps/Full - flow
> control off
> [    6.989657] IPv6: ADDRCONF(NETDEV_CHANGE): eth0: link becomes ready
> 
> I will try again tomorrow with "ethernet-phy-id0007.0771" to see if
> anything changes, since that would use the Microsemi driver rather
> than the Vitesse driver that VSC8662/0007.0660 uses.

The numbers here should be the same as what you find in registers 2
and 3 of the PHY. They identify the manufacture, version and revision
of the PHY. With a normal probe, these two registers are read, and the
PHY driver found which says it supports the particular ID. The only
time you need to actually list the IDs in DT is when you cannot find
the PHY using the normal probe, generally because its regulator/reset
is turned off, and only the PHY driver knows how to fix that.
Chicken/Egg.

You don't have this issue, you always seem to be able to find the PHY,
so you don't need these properties.

Also, using the Microsemi driver for a Vitesse hardware is like using
the intel i210 Ethernet driver for an amd xgbe Ethernet hardware....

    Andrew